(* Title: tests for KEStore.thy
   Author: Walther Neuper
   Use is subject to license terms.

theory Test_Some imports Isac begin 
ML_file "~~/test/Tools/isac/ADDTESTS/accumulate-val/lucas_interpreter.sml"
ML_file "kestore.sml"
*)

"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------";
"-----------------------------------------------------------------------------";
"-------- fun check_kestore_rls ----------------------------------------------";
"-------- fun Test_KEStore_Elems.add_rlss overwrites earlier data ------------";
"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";

"-------- fun check_kestore_rls ----------------------------------------------";
"-------- fun check_kestore_rls ----------------------------------------------";
"-------- fun check_kestore_rls ----------------------------------------------";
if check_kestore_rls ("e_rls", ("KEStore", e_rls)) = 
  "(e_rls, (KEStore, Rls {#calc = 0, #rules = 0, ...))"
then () else error "check_kestore_rls changed"
;
Test_KEStore_Elems.get_rlss @{theory Isac} 
  |> map check_kestore_rls 
  |> enumerate_strings
  |> sort string_ord
(*|> map writeln*)
;

"-------- fun Test_KEStore_Elems.add_rlss overwrites earlier data -----------------";
"-------- fun Test_KEStore_Elems.add_rlss overwrites earlier data -----------------";
"-------- fun Test_KEStore_Elems.add_rlss overwrites earlier data -----------------";
  fun union_overwrite eq l1 l2 = fold (insert eq) l2 (*..swapped..*) l1;
  fun rls_eq ((id1, (thyID1, _)), (id2, (thyID2, _))) = id1 = id2 (*andalso thyID1 = thyID2*)

val data1 = [("test", ("theory-1", Erls)),
  ("test_rls", ("theory-1", 
    append_rls "test_rls" e_rls [Thm ("refl", @{thm refl}), Thm ("subst", @{thm subst})]))]
val data2 = 
  [("test_rls", ("theory-2",
    append_rls "test_rls" e_rls [Thm ("not_def", @{thm not_def})]))]
val data_3a = union rls_eq data1 data2
val data_3b = union_overwrite rls_eq data1 data2

val SOME (_, Rls {rules, ...}) = AList.lookup op = data_3a "test_rls";
case rules of
  [Thm ("not_def", _)] => ()
| _ => error "union rls_eq changed: 1st argument is NOT overwritten anymore"
;
val SOME (_, Rls {rules, ...}) = AList.lookup op = data_3b "test_rls";
case rules of
  [Thm ("refl", _), Thm ("subst", _)] => ()
| _ => error "union_overwrite rls_eq changed: 2nd argument is NOT overwritten anymore"

(* add_rlss will take union_overwrite due to argument sequence *)

